before_script:
  - date
  - uname -p
  - uname -s

stages:
  - validate

validate:
  image: gpdowning/python
  stage: validate
  script:
    # Fetch latest changes
    - git fetch origin
    - echo "$CI_COMMIT_SHA"

    # Check for differences in added files
    - ADDED_FILES=$(git diff --name-only $CI_MERGE_REQUEST_DIFF_BASE_SHA...HEAD)
    - FILE_COUNT=$(echo "$ADDED_FILES" | wc -l)
    - echo "$ADDED_FILES"
    - echo "$FILE_COUNT"

    # Check if exactly 2 files are added
    - if [ $FILE_COUNT -ne 2 ]; then echo "Wrong number of files added."; exit 1; fi

    # Check if one file has "*.in.txt" and the other has "*.out.txt"
    - IN_FILE=$(echo "$ADDED_FILES" | grep "\.in\.txt$")
    - OUT_FILE=$(echo "$ADDED_FILES" | grep "\.out\.txt$")
    - if [ -z "$IN_FILE" ] || [ -z "$OUT_FILE" ]; then echo "Incorrect file patterns."; exit 1; fi

    # Create temporary files for checktestdata and input
    - cat "$IN_FILE" > input.txt

    # clone the scripts repo
    - git clone https://GitLab-CI:${CS373_SCRIPTS_PROJECT_ACCESS_TOKEN}@gitlab.com/gpdowning/cs373-scripts.git

    # Check against input file format
    - checktestdata cs373-scripts/grades/Grades.ctd.txt input.txt

    # copy the validator
    - cp cs373-scripts/grades/grades.py validator_script.py

    # Run the Python script with $IN_FILE as input
    - cat "$IN_FILE" | python validator_script.py > output.txt

    # Compare the program output with the contents of $OUT_FILE
    - cmp output.txt "$OUT_FILE" -s

    # Success message if everything passes
    - echo "Exactly 2 files added with correct patterns, and validation successful."

  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
